//: $CC -DLS_LIB -c $file
#ifndef LS_VECTORC
#define LS_VECTORC
#include "ls_names.h"
#include LS_VECTOR_H

ls_REAL ausl(ls_REAL, ls_REAL);

ls_Vector::ls_Vector(ls_UINT nn, char *nam):
ls_array1<ls_REAL>(nn,nam),eps(ls_EPS){}

ls_Vector::ls_Vector(ls_Vector &v):ls_array1<ls_REAL>(v), eps(v.eps){}

ls_Vector::ls_Vector(ls_REAL *v, ls_UINT l, char *nam):
ls_array1<ls_REAL>(v, l, nam), eps(ls_EPS){}

const ls_Vector& ls_Vector::operator=(const ls_Vector &v)
{ eps=v.eps; ls_array1<ls_REAL>::operator=(v); return *this;}


ls_Vector ls_Vector::operator-() const
{ ls_Vector y; y=*this;
  ls_REAL *yy=y.asArray(), *ye=yy+dim;
  while(yy<ye) *yy=-(*yy), yy++;
  return y;
}

ls_Vector ls_Vector::operator-(const ls_Vector &v) const
{ ls_Vector y; y=*this; y-=v; return y;}

ls_Vector ls_Vector::operator*(ls_REAL v)const
{ ls_Vector y; y=*this; y*=v; return y;}

ls_REAL ls_Vector::operator*(const ls_Vector &v) const
{ ls_REAL *va=v.asArray(), *aa=a, *ve=va+dim;
  double s, sp=0, sm=0;
  while(va<ve){ s=*aa; if((s*=*va)>0) sp+=s; else sm+=s; aa++, va++;}
  return (ls_REAL)(sp+sm);
}

ls_Vector ls_Vector::operator+(const ls_Vector &v) const
{ ls_Vector y; y=*this; y+=v; return y;}

ls_Vector& ls_Vector::operator+=(const ls_Vector &v)
{ ls_REAL *va=v.asArray(), *aa=a, *ve=va+dim;
  while(va<ve){ if(ausl(*aa,-(*va))>eps) *aa+=*va; else *aa=0; aa++, va++;}
  return *this;
}

ls_Vector& ls_Vector::operator-=(const ls_Vector &v)
{ ls_REAL *va=v.asArray(), *ve=va+dim, *aa=a;
  while(va<ve){ if(ausl(*aa,*va)>eps) *aa-=*va; else *aa=0; aa++, va++;}
  return *this;
}

ls_Vector& ls_Vector::operator*=(ls_REAL s)
{ for (ls_REAL *aa=a,*ae=aa+dim; aa<ae; *aa*=s, aa++);return *this;}

ls_Vector operator*(ls_REAL s, const ls_Vector &x)
{ ls_Vector y; y=x; y*=s; return y;}
#endif
