//: $CC -DLS_LIB -c $file
#ifndef LS_ARRAY1C
#define LS_ARRAY1C
#include "ls_names.h"
#include LS_ARRAY1_H

template<class T>
ls_array1<T>::ls_array1(ls_array1<T> &v)
{ strcpy(name=ONAME+1,v.name); *ONAME=0;
  a=v.asArray(); dim=v.dimension(); v.set_data();}

template<class T>
ls_array1<T>::ls_array1(ls_UINT l,char *nam)
{ strcpy(name=ONAME+1,nam); *ONAME=0; if(!(dim=l)) return;
  a=new T[dim], memset(a, 0, sizeof(T)*dim);
}

template<class T>
ls_array1<T>::ls_array1(T *A, ls_UINT l, char *nam)
{ *ONAME=1; strcpy(name=ONAME+1, nam); a=A, A=NULL, dim=l;}

template<class T>
ls_array1<T>::~ls_array1(){ if(dim&&!*ONAME) delete[]a;}

template<class T>
ls_array1<T>& ls_array1<T>::swap(ls_array1<T> &v)
{ char na[ls_len];strcpy(na+1,name);strcpy(name,v.name);strcpy(v.name,na+1);
  *na=*(name-1); *(name-1)=*(v.name-1); *(v.name-1)=*na;
  T *aa=v.asArray(); ls_UINT d=v.dimension();
  v.set_data(a,dim); a=aa; dim=d; return *this;
}

template<class T>
const ls_array1<T>& ls_array1<T>::operator=(const ls_array1<T> &v)
{ static char *q1="ls_array1::operator=";
  T *va=v.asArray();
  ls_UINT vdim=v.dimension();
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  if(a==va) return *this;
  if(!dim) a=new T[dim=vdim];
  if(dim!=vdim) throw ls_error(name,q1,size_error_);
  memcpy(a, va, sizeof(T)*dim);
  return *this;
}

template<class T>
T& ls_array1<T>::operator[](ls_UINT i) const
{
#ifdef LS_TEST
  static char *q1="ls_array1::[]";
  if(!(i<dim)) throw ls_error(name,q1,index_error_);
#endif
  return a[i];
}

template<class T>
ls_array1<T>& ls_array1<T>::put(T v, ls_UINT i)
{
#ifdef LS_TEST
  static char *q1="ls_array1::put";
  if(!(i<dim)) throw ls_error(name,q1,index_error_);
#endif
  a[i]=v; return *this;
}

template<class T>
ls_array1<T>& ls_array1<T>::put_array(const ls_array1<T> &v, ls_UINT i)
{ static char *q1="ls_array1::put_array";
  if(!(i<dim)) throw ls_error(name,q1,index_error_);
  ls_UINT vdim=v.dimension(), ll=(dim-i<vdim)? dim-i:vdim;
  T *aa=a+i+ll-1, *vv=v.asArray()+ll-1;
  while(ll--) *aa=*vv, aa--, vv--;
  return *this;
}

template<class T>
ls_array1<T>& ls_array1<T>::put_array(T s, ls_UINT i)
{
#ifdef LS_TEST
  static char *q1="ls_array1::put_array";
  if(!(i<dim)) throw ls_error(name,q1,index_error_);
#endif
  if(!s) memset(a+i,0,sizeof(T)*(dim-i));else for(; i<dim; a[i++]=s);
  return *this;
}

template<class T>
T ls_array1<T>::get(ls_UINT i)
{
#ifdef LS_TEST
  static char *q1="ls_array1::get";
  if(!(i<dim)) throw ls_error(name,q1,index_error_);
#endif
  return a[i];
}

template<class T>
const ls_array1<T>& ls_array1<T>::get_array(ls_array1<T> &v, ls_UINT i) const
{ static char *q1="ls_array1::get_array";
  if(!(i<dim)) throw ls_error(name,q1,index_error_);
  ls_UINT vdim=v.dimension(), ll=(dim-i<vdim)? dim-i:vdim;
  T *aa=a+i, *vv=v.asArray();
  while(ll--) *vv=*aa, vv++, aa++;
  return *this;
}

template<class T>
ls_array1<T>& ls_array1<T>::append(ls_UINT l)
{ T *aa=new T[dim+l];
  if(dim) memcpy(aa,a,sizeof(T)*dim), delete[]a;
  a=aa, aa=aa+dim, dim+=l; memset(aa,0,sizeof(T)*l);
  return *this;
}

template<class T>
ls_array1<T>& ls_array1<T>::remove(ls_UINT i)
{ static char *q1="ls_array1::remove";
  if(!(i<dim)) throw ls_error(name,q1,index_error_);
  T *aa=new T[dim-1];
  if(i) memcpy(aa,a,sizeof(T)*i);
  if(dim-i-1) memcpy(aa+i,a+i+1,sizeof(T)*(dim-i-1));
  delete[]a, dim--; a=aa;
  return *this;
}

template<class T>
ls_array1<T>& ls_array1<T>::remove()
{ if(dim) delete[]a, dim=0;
  return *this;
}

template<class T>
const ls_array1<T>& ls_array1<T>::write(ostream &f) const
{ static char *q1="ls_array1::write";
  if(!dim) throw ls_error(q1,name,object_is_empty_);
  f<<name<<endl<<"{ "<<dimension_<<" "<<dim<<endl;
  for (T *aa=a, *ae=a+dim; aa<ae; aa++)
    if(*aa<0) f << " " << *aa; else f << "  " << *aa;
  f<<endl<<"}"<<endl;
  return *this;
}

template<class T>
ls_array1<T>& ls_array1<T>::read(istream &f)
{ static char *q1="ls_array1::read";
  if(dim) throw ls_error(name, q1, object_not_empty_);
  char w[ls_len];
  if(*name) while(f>>w&&strcmp(w,name)); else f>>name;
  if(!f.good()) throw ls_error(name, q1, object_not_found_);
  f>>w;
  if(strcmp(w, "{")) throw ls_error(name,q1,object_contents_error_);
  if(!(f>>w)||strcmp(w, dimension_)||!(f>>dim))
    throw ls_error(name, q1, object_contents_error_);
  a=new T[dim];
  for (T *aa=a, *ae=a+dim; aa<ae; f>>*aa, aa++);
  if(!(f>>w)||(*w!='}')) throw ls_error(name, q1, object_end_error_);
  return *this;
}

template<class T>
const ls_array1<T>& ls_array1<T>::operator>> (char *nam) const
{ if(!*nam)
  { cout.setf(ios::fixed, ios::floatfield);
    cout.precision(int(sizeof(ls_REAL)*1.5));
    write(cout);
  }
  else
  { ofstream f(nam);
    f.setf(ios::scientific, ios::floatfield);
    f.precision(int(sizeof(ls_REAL)*1.5)); write(f);
  }
  return *this;
}

template<class T>
ls_array1<T>& ls_array1<T>::operator<< (char *nam)
{ if(!*nam) read(cin); else{ ifstream f(nam); read(f);}
  return *this;
}
#endif
